// ===========================================================================
// Verilog module generated by IPexpress
// Filename: ddr3_sdram_mem_top.v  
// Copyright 2010 (c) Lattice Semiconductor Corporation. All rights reserved.
// ===========================================================================

`timescale 1ns/100ps

module ddr3_sdram_mem_top (

   // Clock and reset
   clk_in,
   rst_n,
   mem_rst_n,

   // Input signals from the User I/F  
   init_start,  
   cmd,
   addr,
   cmd_burst_cnt,
   cmd_valid,   
   ofly_burst_len, 
   write_data,
   data_mask,
   read_pulse_tap,


   // Output signals to the User I/F
   cmd_rdy,
   datain_rdy,
   init_done,
   wl_err,
   read_data,
   read_data_valid,

   // Output for test logic
   sclk_out,
   clocking_good,

   // Memory side signals 
   em_ddr_reset_n,          
   em_ddr_data,
   em_ddr_dqs,
   em_ddr_clk,
   em_ddr_cke,
   em_ddr_ras_n,
   em_ddr_cas_n,
   em_ddr_we_n,
   em_ddr_cs_n,
   em_ddr_odt,
   em_ddr_dm,           
   em_ddr_ba,
   em_ddr_addr
);

// ====================================================================
// Port definition 
// ====================================================================
input                         clk_in;        // System reset
input                         rst_n;         // System reset
input                         mem_rst_n;      // reset to the memory

// Input signals from the User I/F  
input                         init_start; 
input   [3:0]                 cmd;
input   [25:0]                addr;
input   [4:0]                 cmd_burst_cnt;
input                         cmd_valid;
input                         ofly_burst_len;

input   [63:0]               write_data;
input   [7:0]                data_mask;
output  [63:0]               read_data /* synthesis syn_useioff = 0 */;
//pragma attribute read_data outff false

input   [5:0]                read_pulse_tap;



// Output signals to the User I/F
output                        cmd_rdy;
output                        datain_rdy;
output                        init_done;
output                        wl_err;
output                        read_data_valid /* synthesis syn_useioff = 0 */;
//pragma attribute read_data_valid outff false

output                        sclk_out;
output                        clocking_good;

// Memory side signals 
inout   [15:0]                em_ddr_data;
output                        em_ddr_reset_n;
inout   [1:0]                 em_ddr_dqs;
output  [1:0]                 em_ddr_dm;
output  [0:0]                 em_ddr_clk;
output  [0:0]                 em_ddr_cke;
output                        em_ddr_ras_n;
output                        em_ddr_cas_n;
output                        em_ddr_we_n;
output  [0:0]                 em_ddr_cs_n;
output  [0:0]                 em_ddr_odt;
output  [12:0]                em_ddr_addr;
output  [2:0]                 em_ddr_ba;
// ====================================================================
// Wires & Registers
// ====================================================================
wire                             sclk2x /* synthesis syn_keep=1 */;
//pragma attribute sclk2x preserve_signal true
wire                             eclk /* synthesis syn_keep=1 */;
//pragma attribute eclk preserve_signal true
wire                             sclk /* synthesis syn_keep=1 */;
//pragma attribute sclk preserve_signal true

wire                             cmd_rdy;  
wire                             datain_rdy;
wire                             init_done;  
wire                             wl_err;  
wire    [63:0]                  read_data_tmp; 
wire                             read_data_valid_tmp; 
wire                             wl_rst_datapath;
wire                             uddcntln;
wire                             dqsbufd_rst;
wire                             dqsdel;   
wire                             clocking_good;
wire                             rst_p;   

wire    [63:0]                  read_data; 
wire                             read_data_valid; 

wire                             sclk_out;

wire    [15:0]                   em_ddr_data;
wire    [1:0]                    em_ddr_dqs;
wire    [0:0]                    em_ddr_clk;
wire                             em_ddr_reset_n_tmp;
wire                             em_ddr_reset_n;
wire                             em_ddr_ras_n;  
wire                             em_ddr_we_n;   
wire                             em_ddr_cas_n;  
wire    [0:0]                    em_ddr_cs_n;   
wire    [0:0]                    em_ddr_cke;    
wire    [0:0]                    em_ddr_odt;  
wire    [1:0]                    em_ddr_dm;   
wire    [2:0]                    em_ddr_ba; 
wire    [12:0]                   em_ddr_addr; 

assign rst_p = ~rst_n;

assign sclk_out = sclk;

assign #1 em_ddr_reset_n = em_ddr_reset_n_tmp;
//===================================================================
reg     [63:0]                read_data_int_r; 
reg     [63:0]                read_data_int_r1; 
reg     [63:0]                read_data_int_r2; 
reg                           read_data_valid_int_r; 
reg                           read_data_valid_int_r1; 
reg                           read_data_valid_int_r2; 

always @(negedge rst_n or posedge sclk) begin
   if (!rst_n) begin 
      read_data_valid_int_r  <= 1'b0;
      read_data_valid_int_r1 <= 1'b0;
      read_data_valid_int_r2 <= 1'b0;
      read_data_int_r        <= {63{1'b0}};
      read_data_int_r1       <= {63{1'b0}};
      read_data_int_r2       <= {63{1'b0}};
   end    
   else begin
      read_data_valid_int_r  <= read_data_valid_tmp;
      read_data_valid_int_r1 <= read_data_valid_int_r;
      read_data_valid_int_r2 <= read_data_valid_int_r1;
      read_data_int_r        <= read_data_tmp;
      read_data_int_r1       <= read_data_int_r;
      read_data_int_r2       <= read_data_int_r1;
   end  
end 

assign read_data_valid = read_data_valid_int_r1;
assign read_data       = read_data_int_r1;

//===================================================================


ddr3core U1_ddr3core (

   // Clock and reset
   .sclk2x             (sclk2x),
   .eclk               (eclk),
   .sclk               (sclk),
   .rst_n              (rst_n),
   .mem_rst_n          (mem_rst_n),

   // Input signals from the User I/F  
   .init_start         (init_start),  
   .cmd                (cmd),
   .addr               (addr),
   .cmd_burst_cnt      (cmd_burst_cnt),
   .cmd_valid          (cmd_valid),   
   .ofly_burst_len     (ofly_burst_len), 
   .write_data         (write_data),
   .data_mask          (data_mask),
   .read_pulse_tap     (read_pulse_tap),
   .dqsbufd_rst        (dqsbufd_rst),
   .dqsdel             (dqsdel),
   .clocking_good      (clocking_good),


   // Output signals to the User I/F
   .cmd_rdy            (cmd_rdy),
   .datain_rdy         (datain_rdy),
   .init_done          (init_done),
   .wl_err             (wl_err),
   .read_data          (read_data_tmp),
   .read_data_valid    (read_data_valid_tmp),
   .wl_rst_datapath    (wl_rst_datapath),
   .uddcntln           (uddcntln),
   // Memory side signals 
   .em_ddr_reset_n     (em_ddr_reset_n_tmp),
   .em_ddr_data        (em_ddr_data),
   .em_ddr_dqs         (em_ddr_dqs),
   .em_ddr_clk         (em_ddr_clk),
   .em_ddr_cke         (em_ddr_cke),
   .em_ddr_ras_n       (em_ddr_ras_n),
   .em_ddr_cas_n       (em_ddr_cas_n),
   .em_ddr_we_n        (em_ddr_we_n),
   .em_ddr_cs_n        (em_ddr_cs_n),
   .em_ddr_odt         (em_ddr_odt),
   .em_ddr_dm          (em_ddr_dm),           
   .em_ddr_ba          (em_ddr_ba),
   .em_ddr_addr        (em_ddr_addr)
);

ddr3_clks clocking (.reset               (rst_p),
                    .reset_datapath      (wl_rst_datapath),
                    .refclk              (clk_in), 
                    .uddcntln            (uddcntln),
                    .sclk2x              (sclk2x),
                    .eclk                (eclk),
                    .sclk                (sclk),
                    .all_lock            (all_lock), 
                    .reset_datapath_out  (dqsbufd_rst),
                    .align_status        (),
                    .dqsdel              (dqsdel),
                    .good                (clocking_good),
                    .err                 (clocking_err));
//pragma attribute clocking hierarchy preserve

endmodule
